﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Pipeline
{
    /// <summary>
    /// Pipeline control configuration class
    /// </summary>
    public partial class PipelineControlConfig : Form
    {
        /// <summary>
        /// Default constructor of the PipelineControlConfig class. Creates new PipelineControlConfig form.
        /// </summary>
        public PipelineControlConfig()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Refresh time of the pipeline control
        /// </summary>
        /// <remarks>
        /// This property is used for setting a refresh time of the pipeline control.
        /// </remarks>
        public int RefreshTime
        {
            get { return refreshTimer.Interval; }
            protected set { refreshTimer.Interval = value; }
        }


        #region pipeline color configuration

        private void choosePipeColorButton1_Click(object sender, EventArgs e)
        {
            colorDialog1.ShowDialog();
            pipeColorPictureBox.BackColor = colorDialog1.Color;
            okButton.Enabled = true;
        }

        #endregion


        #region refresh time of the control (miliseconds) - default value is 100ms

        private void refreshTimeConfigurationButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.RefreshTime = int.Parse(refreshTimeTextBox.Text);
            }
            catch (FormatException formatError3)
            {
                problemLabel.Text = "Indicator of permitted value is not configured";
                formatError3 = new FormatException("Refresh time value is not entered in a correct format");
                causeOfProblemLabel.Text = formatError3.Message;
            }
        }

        #endregion


        private void okButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }
    }
}
