﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TestSimulation
{
    public partial class Simulation : Form
    {
        public Simulation()
        {
            InitializeComponent();

            //Passing the reference from existing timer objects to Time properties of the two vertical pump controls.
            //With this passing, it is possible to control event method of those timers using existing vertical pump controls.
            verticalPumpControl1.Time = timer1;
            verticalPumpControl2.Time = timer2;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if ((horizontalValveControl1.OpenValve == true) && (verticalPumpControl1.StartPump == true))
            {
                barControl1.StartStopBarControl.Start();
                barControl3.BarColor = barControl1.BarColor;
                barControl3.BarValue = (double)(barControl1.TankCapacity - barControl1.BarValue);

                horizontalValveControl2.Enabled = false;
                verticalPumpControl2.Enabled = false;

                verticalPipeControl1.VerticalPipeValue = barControl1.BarValue;
                bottomLeftCornerPipeControl1.CornerPipeValue = barControl1.BarValue;
                verticalPipeControl3.VerticalPipeValue = barControl1.BarValue;
                bottomLeftCornerPipeControl2.CornerPipeValue = barControl1.BarValue;
                horizontalPipeControl1.HorizontalPipeValue = barControl1.BarValue;
                bottomRightCornerPipeControl2.CornerPipeValue = barControl1.BarValue;

                verticalPipeControl1.BackColor1 = barControl1.BarColor;
                bottomLeftCornerPipeControl1.BackColor1 = barControl1.BarColor;
                verticalPipeControl3.BackColor1 = barControl1.BarColor;
                bottomLeftCornerPipeControl2.BackColor1 = barControl1.BarColor;
                horizontalPipeControl1.BackColor1 = barControl1.BarColor;
                bottomRightCornerPipeControl2.BackColor1 = barControl1.BarColor;
            }
            if ((horizontalValveControl1.OpenValve == false) || (verticalPumpControl1.StartPump == false))
            {
                barControl1.StartStopBarControl.Stop();

                horizontalValveControl2.Enabled = true;
                verticalPumpControl2.Enabled = true;

                verticalPipeControl1.VerticalPipeValue = 0.0;
                bottomLeftCornerPipeControl1.CornerPipeValue = 0.0;
                verticalPipeControl3.VerticalPipeValue = 0.0;
                bottomLeftCornerPipeControl2.CornerPipeValue = 0.0;
                horizontalPipeControl1.HorizontalPipeValue = 0.0;
                bottomRightCornerPipeControl2.CornerPipeValue = 0.0;
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            if ((horizontalValveControl2.OpenValve == true) && (verticalPumpControl2.StartPump == true))
            {
                barControl2.StartStopBarControl.Start();
                barControl3.BarColor = barControl2.BarColor;
                barControl3.BarValue = (double)(barControl2.TankCapacity - barControl2.BarValue);

                horizontalValveControl1.Enabled = false;
                verticalPumpControl1.Enabled = false;

                verticalPipeControl2.VerticalPipeValue = barControl2.BarValue;
                bottomRightCornerPipeControl1.CornerPipeValue = barControl2.BarValue;
                verticalPipeControl3.VerticalPipeValue = barControl2.BarValue;
                bottomLeftCornerPipeControl2.CornerPipeValue = barControl2.BarValue;
                horizontalPipeControl1.HorizontalPipeValue = barControl2.BarValue;
                bottomRightCornerPipeControl2.CornerPipeValue = barControl2.BarValue;

                verticalPipeControl2.BackColor1 = barControl2.BarColor;
                bottomRightCornerPipeControl1.BackColor1 = barControl2.BarColor;
                verticalPipeControl3.BackColor1 = barControl2.BarColor;
                bottomLeftCornerPipeControl2.BackColor1 = barControl2.BarColor;
                horizontalPipeControl1.BackColor1 = barControl2.BarColor;
                bottomRightCornerPipeControl2.BackColor1 = barControl2.BarColor;

            }
            if ((horizontalValveControl2.OpenValve == false) || (verticalPumpControl2.StartPump == false))
            {
                barControl2.StartStopBarControl.Stop();

                horizontalValveControl1.Enabled = true;
                verticalPumpControl1.Enabled = true;

                verticalPipeControl2.VerticalPipeValue = 0.0;
                bottomRightCornerPipeControl1.CornerPipeValue = 0.0;
                verticalPipeControl3.VerticalPipeValue = 0.0;
                bottomLeftCornerPipeControl2.CornerPipeValue = 0.0;
                horizontalPipeControl1.HorizontalPipeValue = 0.0;
                bottomRightCornerPipeControl2.CornerPipeValue = 0.0;
            }
        }

        private void userControlsSimulationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            UserControlSimulation userControlSimulation = new UserControlSimulation();
            userControlSimulation.ShowDialog();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void howToToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OPCstablo.HowToForm howToForm = new OPCstablo.HowToForm();
            howToForm.ShowDialog();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OPCstablo.AboutForm aboutForm = new OPCstablo.AboutForm();
            aboutForm.ShowDialog();
        }
    }
}
